#ifndef HASH_H
#define HASH_H

#include<stdlib.h>
#include<string.h>
#include<ctype.h>
#include<limits.h>
#include<errno.h>
#include"prime.h"

typedef unsigned (key_fn)(void *element);
typedef int (match_fn)(void *element);
typedef void *(hsearch_fn)(void *base,int width,int size,unsigned key,match_fn match);
typedef int (fail_fn)(void *element);

#define hash(key,size) ((key) % (size))
#define rehash(key,prev,size) hash((key)*((prev) + 1),size)
#define kirehash(key,prev,time,size) hash((key) + (prev) + (time),size)

#define hsize(about) closest_prime((about) * (11) / (10))
#define hnew(size,width) calloc(size,width)
#define hdispose(base) free(base)
int hashes;
void *hsearch(void *base,int width,int size,unsigned key,match_fn match);
void *kihsearch(void *base,int width,int size,unsigned key,match_fn match);

#define resize(size,count,ops) ((size) * ((count) + (ops)) / (ops))
#define hnewsize(size,count,ops) hsize(resize(size,count,ops))
void **hresize(void **base,int width,int *size,int newsize,hsearch_fn search,key_fn key,match_fn match,fail_fn fail);
#define HRESIZE (-1923)

unsigned str2key(char *string);
void memswap(void *loc_0,void *loc_1,int size);

/* ordered hashing */

#define ohash(key,size)  (((key) * (size)) / UINT_MAX)
#define OSTRHASH_LEN 16 /* (sizeof(unsigned) << 2) */
int ostrhash(char *string,int size);
int ostrihash(char *string,int size);
int obstrhash(unsigned char *string,int size);


#endif
